local Lib = MissionMinder
Lib.callbacks = Lib.callbacks or LibStub("CallbackHandler-1.0"):New(Lib)

local OPTIONS = Lib.options;
local DEBUG = Lib.debug;
local module = Lib.multiplanner

local L = LibStub("AceLocale-3.0"):GetLocale("MissionMinder");

local function addFollowerToMissionPage(event, missionID, index, followerID, source)
	local MissionPage = GarrisonMissionFrame.MissionTab.MissionPage
	local mission = MissionPage.missionInfo
	if ( source ~= "MissionPage" and mission and mission.missionID == missionID ) then -- Change is not from MissionPage but is for the currently selected mission
		if ( not index ) then
			for i = 1, #MissionPage.Followers do
				if ( not MissionPage.Followers[i].info ) then
					index = i
					break;
				end
			end
		end

		if ( index ) then
			local frame = MissionPage.Followers[index]
			if ( frame ) then
				assert(not frame.info, "Attempt to sync failed. Follower already assigned at index " .. index)
				Lib.planner.setMissionPageFollowerFrame(frame, followerID)
			end
		end
	end
end



local function initialize()
	-- Update MissionPage for follower add
	Lib.RegisterCallback("multiplanner/integration", "FOLLOWER_ADDED_TO_MISSION", addFollowerToMissionPage)

	-- MissionPage should update followerCounters and Traits for its selected mission
	GarrisonMissionFrame.MissionTab.MissionPage:HookScript("OnShow", function(self)
		local mission = self.missionInfo
		if ( mission ) then
			GarrisonMissionFrame.followerCounters = C_Garrison.GetBuffedFollowersForMission(mission.missionID)
			GarrisonMissionFrame.followerTraits = C_Garrison.GetFollowersTraitsForMission(mission.missionID)
			GarrisonFollowerList_DirtyList(GarrisonMissionFrame.FollowerList)
			GarrisonFollowerList_UpdateFollowers(GarrisonMissionFrame.FollowerList)
		end
	end)
end

local events = Lib.events
events:RegisterEvent("multiplanner.integration", "ADDON_LOADED", initialize)
